require 'active_support/concern'
require 'action_dispatch/routing'
require 'action_dispatch/journey'

module Genericer
  class DJRoutes < ActionDispatch::Journey::Routes
    def initialize
      super
    end
  end
  class DJRouter < ActionDispatch::Journey::Router
    def initialize(routes, params)
      super
    end
  end
  class DJJourner < ActionDispatch::Journey::Path::Pattern
    def initialize(path)
      super
    end
  end
  module General
    def self.included(base)
      base.class_eval do
        def self.general(name, value)
          @g ||= []
          @g << name
          self.class.send(:attr_accessor, name)
          self.send("#{name}=", value)
        end

        def self.inherited(sc)
          @g.each do |a|
            sc.general(a, self.send(a).deep_dup)
          end
        end
      end
    end
  end
end

module Generic
  class Routing
    attr_reader :scope, :jr, :before_actions, :after_actions, :fail

    def initialize(options)
      @scope    = options[:scope]
      @before_actions   = options[:before_actions]
      @after_actions    = options[:after_actions]
      @fail       = options[:fail]
      ready(options[:rd])
    end

    def call(env)
      response = jr.call(env)
      if response[0] == 404 and fail
        fail.call(env)
      else
        response
      end
    end

    def ready(rd)
      routes = Genericer::DJRoutes.new
      @jr = Genericer::DJRouter.new(routes, {})
      rd.each do |path, options, handler|
        pat         = Genericer::DJJourner.new(path)
        guard       = options.fetch(:guard, {})
        defaults    = options.fetch(:defaults, {})
        @jr.routes.add_route(Generic::InsEval.hand(scope, handler, before_actions, after_actions),
                                  pat,
                                  guard,
                                  defaults)
      end
    end
  end
end
